## emscripten 2.0.13~dfsg

=== debian/changelog ===
emscripten (2.0.13~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * copyright:
    + update list of repackaging-excluded files
    + update coverage
  * update source-only part of upstream source-map script
  * unfuzz patches
  * use debhelper compatibility level 13 (not 12)
  * update documentation source path
  * fix really tighten build-dependency on binaryen
    (not only runtime dependency),
    as intended since 2.0.10~dfsg-1

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 18 Jul 2021 21:12:38 +0200
