=== debian/changelog ===
emscripten (3.1.5~dfsg-3ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Feb 2022 21:59:26 +0100

emscripten (3.1.5~dfsg-3) unstable; urgency=medium

  * extend patch 1007
    to skip failing test other.test_closure_type_annotations;
    unfuzz patches
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 21:41:57 +0100

emscripten (3.1.5~dfsg-2) experimental; urgency=medium

  * fix add another patch to avoid SjLj;
    unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 14:22:41 +0100

emscripten (3.1.5~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update source-only part of upstream source-map script
  * add another patch to avoid SjLj
  * unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 21 Feb 2022 12:20:22 +0100

emscripten (3.1.4~dfsg-7ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Feb 2022 20:40:22 +0100

emscripten (3.1.4~dfsg-7) unstable; urgency=medium

  * fix autopkgtest

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 17 Feb 2022 13:00:38 +0100

emscripten (3.1.4~dfsg-6) unstable; urgency=medium

  * update testsuite coverage
  * add patch 2014 to avoid root bypass of frozen cache

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 21:46:17 +0100

emscripten (3.1.4~dfsg-5) experimental; urgency=medium

  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 15:57:12 +0100

emscripten (3.1.4~dfsg-4) experimental; urgency=medium

  * fix install cache frozen
  * update patch 2013: fix syntax for resolving wasm2c
  * avoid installing cache sanity hint

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Feb 2022 11:58:37 +0100

emscripten (3.1.4~dfsg-3) experimental; urgency=medium

  * add more patches to avoid SjLj;
    add section about Wasm SjLj support to README.Debian

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 23:24:26 +0100

emscripten (3.1.4~dfsg-2) experimental; urgency=medium

  * add patches to avoid SjLj using Wasm EH instructions
  * extend patch 1007
    to skip failing test other.test_closure_webgpu
  * unfuzz patches
  * install system-shared emscripten config file,
    to not have it generated (and fail) initial call
    to any emscripten tool
  * build and install cache of non-port libraries;
    drop section about code cache from README.Debian
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 20:15:45 +0100

emscripten (3.1.4~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * unfuzz patches
  * generate html and plaintext documentation from upstream markdown;
    build-depend on cmark-gfm
  * update source-only part of upstream source-map script

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 15 Feb 2022 10:34:03 +0100

emscripten (3.1.3~dfsg-5ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Feb 2022 09:26:31 +0100

emscripten (3.1.3~dfsg-5) unstable; urgency=medium

  * improve support for closure-compiler:
    + update patch 2009 to only fake version check,
      which is broken in old closure-compiler in Debian
      (i.e. drop broken changes to internal default)
    + extend patch 2011
      to use system-shared closure-compiler by default
    + update README.Debian
      with expected error message for too old closure-compiler
    closes bug#1005294, thanks to Jeremy James
  * avoid ccache (really not supported):
    + drop patch 2014
    + adjust build rules

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 11 Feb 2022 16:39:34 +0100

emscripten (3.1.3~dfsg-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Feb 2022 12:31:27 +0100

emscripten (3.1.3~dfsg-4) unstable; urgency=medium

  * fix avoid tests test_sdl2_config test_sdl2_ttf
    requiring download of Emscripten port;
    closes: bug#1004953, thanks to Gianfranco Costamagna

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 04 Feb 2022 11:11:18 +0100

emscripten (3.1.3~dfsg-3ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix testsuite by ignoring LDFLAGS passed by Ubuntu build system
    - Ignore cmake tests in other tests
    - Ignore also test_sdl2_ttf, trying to reach github
      (Closes: #1004953)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 04 Feb 2022 10:59:39 +0100

emscripten (3.1.3~dfsg-3) unstable; urgency=medium

  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 15:30:44 +0100

emscripten (3.1.3~dfsg-2) unstable; urgency=medium

  * update and tighten lintian overrides
  * update testsuite coverage
  * update TODOs

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 12:02:22 +0100

emscripten (3.1.3~dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file:
    + ignore version of embedded type definitions,
      to not confuse tracker.debian.org
      (bug#1000969 fixed but website still failing)
  * unfuzz patches
  * update source-only part of upstream source-map script

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 03 Feb 2022 01:22:19 +0100

emscripten (3.1.2~dfsg+~1.39.6-6ubuntu1) jammy; urgency=medium


