=== debian/control ===
--- 
+++ 
@@ -5,30 +5,34 @@
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
- binaryen (>= 99) <!nocheck>,
- clang (>= 1:11.0) <!nocheck>,
+ binaryen (<< 105+) <!nocheck>,
+ binaryen (>= 105) <!nocheck>,
+ clang-13 <!nocheck>,
  cmake <!nocheck>,
+ cmark-gfm <!nodoc>,
+ debhelper-compat (= 13),
+ dh-sequence-python3,
  eslint <!nocheck>,
  fonts-liberation <!nocheck>,
- libsimde-dev,
- lld (>= 1:11.0) <!nocheck>,
- llvm (>= 1:11.0) <!nocheck>,
- debhelper-compat (= 13),
- dh-sequence-python3,
  help2man,
  htmlmin <!nocheck>,
+ jq,
  libjs-source-map,
+ libsimde-dev,
+ lld-13 <!nocheck>,
+ llvm-13 <!nocheck>,
  node-acorn <!nocheck>,
- nodejs <!nocheck>,
+ node-source-map <!nocheck>,
+ nodejs (>= 12.16) <!nocheck>,
  python3,
  python3-numpy <!nocheck>,
  python3-ply <!nocheck>,
  scons <!nocheck>,
- wabt <!nocheck>,
+ wabt (>= 1.0.24-2~) <!nocheck>,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nocheck>,
  python3-sphinx <!nodoc>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: http://emscripten.org/
 Vcs-Browser: https://salsa.debian.org/js-team/emscripten
 Vcs-Git: https://salsa.debian.org/js-team/emscripten.git
@@ -37,12 +41,13 @@
 Package: emscripten
 Architecture: all
 Depends:
- binaryen (>= 99),
- clang (>= 1:11.0),
- lld (>= 1:11.0),
- llvm (>= 1:11.0),
+ binaryen (<< 105+),
+ binaryen (>= 105),
+ clang-13,
+ lld-13,
+ llvm-13,
  node-acorn,
- nodejs,
+ nodejs (>= 12),
  ${misc:Depends},
  ${python3:Depends},
 Recommends:
@@ -53,10 +58,13 @@
  automake,
  closure-compiler,
  cmake,
+ emscripten-doc,
  make,
  python3-ply,
  scons,
- wabt,
+ wabt (>= 1.0.24-2~),
+Provides:
+ node-types-emscripten (= ${types:Version}),
 Description: LLVM-to-JavaScript Compiler
  Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
  called LLVM IR (which can be generated from C/C++ using Clang, or any other
@@ -69,7 +77,7 @@
      to JavaScript and interpreting code in that on the web
  .
  Some uses of emscripten require additional packages:
-  * setting WASM2C requires wabt.
+  * setting WASM2C requires wabt (at least release 1.0.24-2).
   * emcmake requires cmake.
   * emconfigure may require automake.
   * emmake requires make.
